// VRML Generator
// (c) Justin Couch 1996
//
// From Chapter 13 Late Night VRML 2.0 and Java
//
// GroupingNode abstract class. Base class for all the Grouping Nodes and
// SpecialGroups

package geometry;

import java.io.PrintStream;
import java.util.Vector;
import vrml.external.field.EventInMFNode;
import geometry.VrmlObject;

public abstract class GroupingNode extends VrmlObject
{
	protected EventInMFNode		_addChildren;
	protected EventInMFNode		_removeChildren;
	protected EventInMFNode		_set_children;

	protected Vector		_children = null;
	protected float[]		_bboxCenter = null;
	protected float[]		_bboxSize = null;


	// make this a protected constructor so that you cannot instantiate a
	// copy of this node directly.
	protected GroupingNode()
	{
	}

	public abstract void writeToFile(PrintStream fp, int indent);
	public abstract void addChildren(VrmlObject child);
	public abstract void removeChildren(VrmlObject child);
	public abstract void set_children(VrmlObject[] child_list);

}